-- Create a frame to listen for events:
local dbars = CreateFrame("Frame", "DejaBarsFrame")
dbars:SetFrameStrata("BACKGROUND")
dbars:SetWidth(372)
dbars:SetHeight(26)
dbars:SetPoint("CENTER", UIParent, "BOTTOM", 0, 16)
dbars:Show()

-- Register the events to listen for:
dbars:RegisterEvent("PLAYER_LOGIN")
dbars:RegisterEvent("PLAYER_ENTERING_WORLD")
dbars:RegisterEvent("ADDON_LOADED")
dbars:RegisterEvent("UPDATE_SHAPESHIFT_FORM")
dbars:RegisterEvent("UPDATE_SHAPESHIFT_FORMS")
dbars:RegisterEvent("UPDATE_STEALTH")
dbars:RegisterEvent("PET_BATTLE_OVER")
dbars:RegisterEvent("UPDATE_BONUS_ACTIONBAR")
dbars:RegisterEvent("CINEMATIC_STOP")


-- Set the function to be run when the frame receives
-- an event it's listening for:
dbars:SetScript("OnEvent", function(self, event, ...)
	-- If you're in combat, stop here:
	if InCombatLockdown() then return end
	-- Only run the rest if you're not in combat:



	MainMenuBarLeftEndCap:Hide()
	MainMenuBarRightEndCap:Hide()

	MainMenuBarTexture0:Hide()
	MainMenuBarTexture1:Hide()
	MainMenuBarTexture2:Hide()
	MainMenuBarTexture3:Hide()
	
	MainMenuBarPageNumber:Hide()
	ActionBarUpButton:Hide()
	ActionBarDownButton:Hide()        

	MainMenuExpBar:SetAlpha(1)
	ReputationWatchBar:SetAlpha(1)
	
	MainMenuBarBackpackButton:Hide()
	CharacterBag0Slot:Hide()
	CharacterBag1Slot:Hide()
	CharacterBag2Slot:Hide()
	CharacterBag3Slot:Hide()
	
	MainMenuMaxLevelBar0:Hide()
	MainMenuMaxLevelBar1:Hide()
	MainMenuMaxLevelBar2:Hide()
	MainMenuMaxLevelBar3:Hide()

	StanceBarLeft:SetTexture(nil)
	StanceBarMiddle:SetTexture(nil)
	StanceBarRight:SetTexture(nil)
	
	SlidingActionBarTexture0:SetTexture(nil)
	SlidingActionBarTexture1:SetTexture(nil)
	
	PossessBackground1:SetTexture(nil)
	PossessBackground2:SetTexture(nil)



--Main Bars
	MainMenuBar:SetScale(0.75)
	MainMenuBar:SetFrameStrata("BACKGROUND")
	
	ActionButton1:ClearAllPoints()
	ActionButton1:SetPoint("CENTER", dbars, "LEFT", 16, 0)



	MultiBarBottomRightButton1:ClearAllPoints()
	MultiBarBottomRightButton1:SetPoint("CENTER", 	MultiBarBottomLeftButton1, "CENTER", 0, 42)

local MultiBarBR = CreateFrame("Frame", "MultiBarBRFrame")
	MultiBarBR:SetFrameStrata("BACKGROUND")
	MultiBarBR:SetWidth(372)
	MultiBarBR:SetHeight(26)
	MultiBarBR:SetPoint("CENTER", UIParent, "BOTTOM", 0, 80)
	MultiBarBR:Show()

local function Fade(alpha)
        if MultiBarBR:IsShown() then
            for i = 1,12 do
                local button = _G["MultiBarBottomRightButton"..i]
                button:SetAlpha(alpha)
            end
        end
    end    
    MultiBarBR:EnableMouse(true)
    MultiBarBR:SetScript("OnEnter", function(self) Fade(1) end)
    MultiBarBR:SetScript("OnLeave", function(self) Fade(0) end)  
    for i = 1,12 do
        local button = _G["MultiBarBottomRightButton"..i]
        button:SetAlpha(0)
        button:HookScript("OnEnter", function(self) Fade(1) end)
        button:HookScript("OnLeave", function(self) Fade(0) end)
    end


	MultiBarBottomLeftButton1:ClearAllPoints()
	MultiBarBottomLeftButton1:SetPoint("CENTER", ActionButton1, "CENTER", 0, 42)



local MultiBarBL = CreateFrame("Frame", "MultiBarBLFrame")
	MultiBarBL:SetFrameStrata("BACKGROUND")
	MultiBarBL:SetWidth(372)
	MultiBarBL:SetHeight(26)
	MultiBarBL:SetPoint("CENTER", UIParent, "BOTTOM", 0, 48)
	MultiBarBL:Show()

local function Fade(alpha)
        if MultiBarBL:IsShown() then
            for i = 1,12 do
                local button = _G["MultiBarBottomLeftButton"..i]
                button:SetAlpha(alpha)
            end
        end
    end    
    MultiBarBL:EnableMouse(true)
    MultiBarBL:SetScript("OnEnter", function(self) Fade(1) end)
    MultiBarBL:SetScript("OnLeave", function(self) Fade(0) end)  
    for i = 1,12 do
        local button = _G["MultiBarBottomLeftButton"..i]
        button:SetAlpha(0)
        button:HookScript("OnEnter", function(self) Fade(1) end)
        button:HookScript("OnLeave", function(self) Fade(0) end)
    end



--Micro Menu Buttons
	CharacterMicroButton:ClearAllPoints()
	CharacterMicroButton:SetPoint("LEFT", 
	MultiBarBottomRightButton12, "TOPRIGHT", 0, -4)

	AchievementMicroButton:ClearAllPoints()
	AchievementMicroButton:SetPoint("TOP", CharacterMicroButton, "BOTTOM", 0, 25)

	PVPMicroButton:ClearAllPoints()
	PVPMicroButton:SetPoint("TOP", AchievementMicroButton, "BOTTOM", 0, 25)

	EJMicroButton:ClearAllPoints()
	EJMicroButton:SetPoint("TOP", PVPMicroButton, "BOTTOM", 0, 25)



local function showMBB(self)
 	for _, v in ipairs(MICRO_BUTTONS) do
    		_G[v]:SetAlpha(1)
    	end
end
     
local function hideMBB(self)
	for _, v in ipairs(MICRO_BUTTONS) do
     		_G[v]:SetAlpha(0)
    	end
end
     
	for _, v in ipairs(MICRO_BUTTONS) do
     		v = _G[v]
        	v:HookScript("OnEnter", showMBB)
        	v:HookScript("OnLeave", hideMBB)
        	v:SetAlpha(0)
		v:SetScale(0.93)
	end



--Left/Right Bars
	MultiBarRight:SetScale(0.56)

	MultiBarLeftButton1:ClearAllPoints()
	MultiBarLeftButton1:SetPoint("LEFT", TalentMicroButton, "RIGHT", 0, -12)
	MultiBarLeftButton5:ClearAllPoints()
	MultiBarLeftButton5:SetPoint("LEFT", MultiBarLeftButton1, "RIGHT", 4, 0)
	MultiBarLeftButton9:ClearAllPoints()
	MultiBarLeftButton9:SetPoint("LEFT", MultiBarLeftButton5, "RIGHT", 4, 0)

local LeftMB = CreateFrame("Frame", "LeftMBFrame")
	LeftMB:SetFrameStrata("BACKGROUND")
	LeftMB:SetWidth(66)
	LeftMB:SetHeight(90)
	LeftMB:SetPoint("TOPLEFT", MultiBarLeftButton1, "TOPLEFT", 0, 0)
	LeftMB:Show()

local function Fade(alpha)
     	if LeftMB:IsShown() then
       	for i = 1,12 do
           	local button = _G["MultiBarLeftButton"..i]
                button:SetAlpha(alpha)
          	end
    	end
end    
  	LeftMB:EnableMouse(true)
    	LeftMB:SetScript("OnEnter", function(self) Fade(1) end)
    	LeftMB:SetScript("OnLeave", function(self) Fade(0) end)  
    	for i = 1,12 do
        	local button = _G["MultiBarLeftButton"..i]
        	button:SetAlpha(0)
        	button:HookScript("OnEnter", function(self) Fade(1) 			end)
        	button:HookScript("OnLeave", function(self) Fade(0) 			end)
    	end



	MultiBarRightButton1:ClearAllPoints()
	MultiBarRightButton1:SetPoint("LEFT", MultiBarLeftButton9, "RIGHT", 4, 0)
	MultiBarRightButton5:ClearAllPoints()
	MultiBarRightButton5:SetPoint("LEFT", MultiBarRightButton1, "RIGHT", 4, 0)
	MultiBarRightButton9:ClearAllPoints()
	MultiBarRightButton9:SetPoint("LEFT", MultiBarRightButton5, "RIGHT", 4, 0)

local RightMB = CreateFrame("Frame", "RightMBFrame")
	RightMB:SetFrameStrata("BACKGROUND")
	RightMB:SetWidth(66)
	RightMB:SetHeight(90)
	RightMB:SetPoint("TOPLEFT", MultiBarRightButton1, "TOPLEFT", 0, 0)
	RightMB:Show()

local function Fade(alpha)
     	if RightMB:IsShown() then
       	for i = 1,12 do
           	local button = _G["MultiBarRightButton"..i]
                button:SetAlpha(alpha)
         	end
    	end
end    
    	RightMB:EnableMouse(true)
    	RightMB:SetScript("OnEnter", function(self) Fade(1) end)
    	RightMB:SetScript("OnLeave", function(self) Fade(0) end)  
    	for i = 1,12 do
        	local button = _G["MultiBarRightButton"..i]
        	button:SetAlpha(0)
        	button:HookScript("OnEnter", function(self) Fade(1) 			end)
        	button:HookScript("OnLeave", function(self) Fade(0) 			end)
	end



--Stance/Shapeshift bars
	StanceButton1:ClearAllPoints()
	StanceButton1:SetPoint("LEFT", PetActionButton1, "LEFT", 0, 36)

local StanceBar = CreateFrame("Frame", "StanceBarFrame")
	StanceBar:SetFrameStrata("BACKGROUND")
	StanceBar:SetWidth(160)
	StanceBar:SetHeight(22)
	StanceBar:SetPoint("LEFT", PetActionButton1, "LEFT", 2, 26)
	StanceBar:Show()

local function Fade(alpha)
    	if StanceBar:IsShown() then
       	for i = 1,10 do
            	local button = _G["StanceButton"..i]
                button:SetAlpha(alpha)
          	end
     	end
end    
    	StanceBar:EnableMouse(true)
    	StanceBar:SetScript("OnEnter", function(self) Fade(1) end)
    	StanceBar:SetScript("OnLeave", function(self) Fade(0) end)  
    	for i = 1,10 do
        	local button = _G["StanceButton"..i]
        	button:SetAlpha(0)
        	button:HookScript("OnEnter", function(self) Fade(1) 			end)
        	button:HookScript("OnLeave", function(self) Fade(0) 			end)
	end



--Pet Action Bars
	PetActionButton1:ClearAllPoints()
	PetActionButton1:SetPoint("LEFT", MultiBarBottomRightButton1, "LEFT", 0, 36)

local PetBar = CreateFrame("Frame", "PetBarFrame")
	PetBar:SetFrameStrata("BACKGROUND")
	PetBar:SetWidth(276)
	PetBar:SetHeight(22)
	PetBar:SetPoint("LEFT", MultiBarBR, "LEFT", 0, 26)
	PetBar:Show()

local function Fade(alpha)
    	if PetBar:IsShown() then
       	for i = 1,10 do
             	local button = _G["PetActionButton"..i]
                button:SetAlpha(alpha)
         	end
    	end
end    
    	PetBar:EnableMouse(true)
    	PetBar:SetScript("OnEnter", function(self) Fade(1) end)
    	PetBar:SetScript("OnLeave", function(self) Fade(0) end)  
    	for i = 1,10 do
        	local button = _G["PetActionButton"..i]
        	button:SetAlpha(0)
        	button:HookScript("OnEnter", function(self) Fade(1) 			end)
        	button:HookScript("OnLeave", function(self) Fade(0) 			end)
	end


--This function is here because the PetActionBarFrame strata is --higher than MultiBarBR
local function Fade(alpha)
  	if PetActionBarFrame:IsShown() then
      	for i = 1,12 do
           	local button = _G["MultiBarBottomRightButton"..i]
                button:SetAlpha(alpha)
         	end
    	end
end    
    	PetActionBarFrame:EnableMouse(true)
    	PetActionBarFrame:SetScript("OnEnter", function(self) Fade(1) 	end)
    	PetActionBarFrame:SetScript("OnLeave", function(self) Fade(0) 	end)  
    	for i = 1,12 do
        	local button = _G["MultiBarBottomRightButton"..i]
        	button:SetAlpha(0)
        	button:HookScript("OnEnter", function(self) Fade(1) 			end)
        	button:HookScript("OnLeave", function(self) Fade(0) 			end)
	end



end)