--Register Events
local mm = CreateFrame("Frame", "DejaMinimapFrame")
mm:RegisterEvent("PLAYER_LOGIN")
mm:RegisterEvent("PLAYER_ENTERING_WORLD")
mm:RegisterEvent("ADDON_LOADED")
mm:RegisterEvent("PET_BATTLE_OVER")
mm:RegisterEvent("UPDATE_INSTANCE_INFO")


--Hide Frames
local function eventHandler(self, event, ...)



		MinimapBorder:Hide()
		MinimapBorderTop:Hide()
		MinimapZoomIn:Hide()
		MinimapZoomOut:Hide()
		MinimapNorthTag:Hide()
		MiniMapTracking:SetAlpha(0)



for i = 1, 1 do
	if TimeManagerClockButton then
		TimeManagerClockButton:SetAlpha(0)
	end
end


--Minimap
Minimap:SetMovable(1)
Minimap:EnableMouse(1)
Minimap:RegisterForDrag("RightButton")
Minimap:SetClampedToScreen(1)
Minimap:SetScale(0.85)
Minimap:SetMaskTexture('Interface\\ChatFrame\\ChatFrameBackground')

Minimap:SetScript("OnMouseDown", function(self, button)
 	if button == "RightButton" and IsShiftKeyDown() and not self.isMoving then
   		self:StartMoving()
   		self.isMoving = true
  	end
end)

Minimap:SetScript("OnMouseUp", function(self, button)
  	if button == "RightButton" and self.isMoving then
   		self:StopMovingOrSizing()
   		self.isMoving = false
  	end
end)

Minimap:EnableMouseWheel(true)
Minimap:SetScript("OnMouseWheel", function(mp, input)
local zoom = Minimap:GetZoom()
    if input > 0 and zoom < 5 then
		mp:SetZoom(zoom +1)
    elseif input < 0 and zoom > 0 then
		mp:SetZoom(zoom -1)
    end
end)

MiniMapTracking:ClearAllPoints()
MiniMapTracking:SetPoint("TOPLEFT", Minimap, "TOPLEFT", 0, 0)

QueueStatusMinimapButton:ClearAllPoints()
QueueStatusMinimapButton:SetPoint("CENTER", Minimap, "LEFT", 0, 0)

MinimapZoneTextButton:ClearAllPoints()
MinimapZoneTextButton:SetPoint("CENTER", Minimap, "TOP", 0, 15)
MinimapZoneTextButton:SetFrameStrata("HIGH")

MiniMapInstanceDifficulty_AdjustPosition = function() end
MiniMapInstanceDifficulty:SetParent(UIParent)
MiniMapInstanceDifficulty:SetScale(0.5)
MiniMapInstanceDifficulty:ClearAllPoints()
MiniMapInstanceDifficulty:SetPoint("TOPLEFT", Minimap, "TOPLEFT", 0, 0)

GuildInstanceDifficulty_AdjustPosition = function() end
GuildInstanceDifficulty:SetParent(UIParent)
GuildInstanceDifficulty:SetScale(0.5)
GuildInstanceDifficulty:ClearAllPoints()
GuildInstanceDifficulty:SetPoint("TOPLEFT", Minimap, "TOPLEFT", 0, 0)

MiniMapMailBorder:SetAlpha(0)
MiniMapMailFrame:SetScale(1.25)
MiniMapMailFrame:ClearAllPoints()
MiniMapMailFrame:SetPoint("TOPRIGHT", Minimap, "TOPRIGHT", 7, 5)

GameTimeFrame:SetAlpha(0)
GameTimeFrame:ClearAllPoints()
GameTimeFrame:SetPoint("TOPRIGHT", Minimap, "TOPRIGHT", 0, 0)

MiniMapWorldMapButton:SetScale(1.5)
MiniMapWorldMapButton:SetAlpha(0)
MiniMapWorldMapButton:ClearAllPoints()
MiniMapWorldMapButton:SetPoint("TOP", Minimap, "TOP", 0, 10)

MiniMapRecordingBorder:SetAlpha(0)
MiniMapRecordingButton:ClearAllPoints()
MiniMapRecordingButton:SetPoint("BOTTOMLEFT", Minimap, "BOTTOMLEFT", 0, 0)



--End Event Registration
end
mm:SetScript("OnEvent",eventHandler)



--Clock
local use24hformat = false

local clock = CreateFrame("Frame", nil, UIParent)
clock:SetFrameStrata("MEDIUM")
clock:SetWidth(10)
clock:SetHeight(2)
clock:SetPoint("BOTTOM", Minimap, "BOTTOM", 0, 0)
clock:Show()

clock:RegisterEvent("ZONE_CHANGED")
clock:RegisterEvent("ZONE_CHANGED_INDOORS")
clock:RegisterEvent("ZONE_CHANGED_NEW_AREA")

local clockFS = clock:CreateFontString("FontString","OVERLAY","GameTooltipText")

clockFS:SetPoint("BOTTOM",clock,"BOTTOM",0,0)

local elapsed = 0
clock:SetScript("OnUpdate", function(self, e)
   elapsed = elapsed + e
   if elapsed >= 1 then
       MinimapClockRefresh()
       elapsed = 0
   end
end)

clock:SetScript("OnEvent", function()
       clockFS:SetTextColor(1, 1, 1);
       MinimapClockRefresh()
end)

function MinimapClockRefresh()
	if use24hformat then
		clockFS:SetText(date("%H:%M"))
	else
		clockFS:SetText(("%d:%s"):format(tonumber(date("%I")),((date("%M%p")))))
	end
end



--Coordinates
local coordframe = CreateFrame("Frame", nil, statframe)
coordframe:SetFrameStrata("MEDIUM")
coordframe:SetWidth(100)
coordframe:SetHeight(26)
coordframe:SetPoint("TOP", Minimap, "TOP", 0, 0)
coordframe:Show()

coordframe:RegisterEvent("ZONE_CHANGED")
coordframe:RegisterEvent("ZONE_CHANGED_INDOORS")
coordframe:RegisterEvent("ZONE_CHANGED_NEW_AREA")

local coordframeFS = coordframe:CreateFontString("FontString","OVERLAY","GameTooltipText")
local coordFS = coordframe:CreateFontString("FontString","OVERLAY","GameTooltipText")

coordFS:SetPoint("TOP",coordframe,"TOP",0,0)

local elapsed = 0
coordframe:SetScript("OnUpdate", function(self, e)
   elapsed = elapsed + e
   if elapsed >= 1 then
       coordRefresh()
       elapsed = 0
   end
end)

coordframe:SetScript("OnEvent", function()
       coordFS:SetTextColor(1, 1, 1);
       coordRefresh()
end)

function coordRefresh()
	local posX, posY = GetPlayerMapPosition("player")
		coordFS:SetFormattedText("%.1f, %.1f", posX*100, posY*100)
end

