--Stat Frame
local statframe = CreateFrame("Frame", "StatFrame", UIParent)
statframe:SetMovable(1) -- this and following 3 lines make window movable with mouse
statframe:EnableMouse(1)
statframe:RegisterForDrag("RightButton")
statframe:SetClampedToScreen(1)


statframe:SetPoint("CENTER")
statframe:SetWidth(175)
statframe:SetHeight(50)

statframe:SetAlpha(0.25)
statframe:SetScript("OnEnter", function(self)
	self:SetAlpha(1)
end)
statframe:SetScript("OnLeave", function(self)
	self:SetAlpha(0.25)
end)

statframe:RegisterEvent("ZONE_CHANGED")
statframe:RegisterEvent("ZONE_CHANGED_INDOORS")
statframe:RegisterEvent("ZONE_CHANGED_NEW_AREA")

statframe:SetScript("OnMouseDown", function(self, button)
	if button == "RightButton" and IsShiftKeyDown() and not self.isMoving then
		self:StartMoving()
   		self.isMoving = true
  	end
end)

statframe:SetScript("OnMouseUp", function(self, button)
 	if button == "RightButton" and self.isMoving then 				self:StopMovingOrSizing()
   		self.isMoving = false
  	end
end)

--Framerate
local fpsframe = CreateFrame("Frame", nil, statframe)
fpsframe:SetFrameStrata("BACKGROUND")
fpsframe:SetWidth(100)
fpsframe:SetHeight(26)
fpsframe:SetPoint("TOPRIGHT", statframe, "TOPRIGHT", 0, 0)
fpsframe:Show()

fpsframe:RegisterEvent("ZONE_CHANGED")
fpsframe:RegisterEvent("ZONE_CHANGED_INDOORS")
fpsframe:RegisterEvent("ZONE_CHANGED_NEW_AREA")

local fpsframeFS = fpsframe:CreateFontString("FontString","OVERLAY","GameTooltipText")

fpsframeFS:SetPoint("BOTTOMRIGHT",fpsframe,"BOTTOMRIGHT",0,0)

local elapsed = 0
fpsframe:SetScript("OnUpdate", function(self, e)
   elapsed = elapsed + e
   if elapsed >= 1 then
       fpsframeRefresh()
       elapsed = 0
   end
end)

fpsframe:SetScript("OnEvent", function()
       fpsframeFS:SetTextColor(1, 1, 1);
       fpsframeRefresh()
end)

function fpsframeRefresh()
	local framerate = GetFramerate()
	fpsframeFS:SetFormattedText("%.1f fps", framerate)
end



--Latency
local latencyframe = CreateFrame("Frame", nil, statframe)
latencyframe:SetFrameStrata("BACKGROUND")
latencyframe:SetWidth(100)
latencyframe:SetHeight(26)
latencyframe:SetPoint("RIGHT", statframe, "RIGHT", 0, 0)
latencyframe:Show()

latencyframe:RegisterEvent("ZONE_CHANGED")
latencyframe:RegisterEvent("ZONE_CHANGED_INDOORS")
latencyframe:RegisterEvent("ZONE_CHANGED_NEW_AREA")

local latencyframeFS = latencyframe:CreateFontString("FontString","OVERLAY","GameTooltipText")
local latencyFS = latencyframe:CreateFontString("FontString","OVERLAY","GameTooltipText")

latencyFS:SetPoint("BOTTOMRIGHT",latencyframe,"BOTTOMRIGHT",0,0)

local elapsed = 0
latencyframe:SetScript("OnUpdate", function(self, e)
   elapsed = elapsed + e
   if elapsed >= 1 then
       latencyRefresh()
       elapsed = 0
   end
end)

latencyframe:SetScript("OnEvent", function()
       latencyFS:SetTextColor(1, 1, 1);
       latencyRefresh()
end)

function latencyRefresh()
	bandwidthIn, bandwidthOut, latencyHome, latencyWorld = GetNetStats()
	latencyFS:SetFormattedText("%.0f ms", latencyWorld)
end



--Gold
local goldframe = CreateFrame("Frame", nil, statframe)
goldframe:SetFrameStrata("BACKGROUND")
goldframe:SetWidth(100)
goldframe:SetHeight(26)
goldframe:SetPoint("BOTTOMLEFT", statframe, "BOTTOMLEFT", 0, 0)
goldframe:Show()

goldframe:RegisterEvent("ZONE_CHANGED")
goldframe:RegisterEvent("ZONE_CHANGED_INDOORS")
goldframe:RegisterEvent("ZONE_CHANGED_NEW_AREA")

local goldframeFS = goldframe:CreateFontString("FontString","OVERLAY","GameTooltipText")
local goldFS = goldframe:CreateFontString("FontString","OVERLAY","GameTooltipText")

goldFS:SetPoint("BOTTOMLEFT",goldframe,"BOTTOMLEFT",0,0)

local elapsed = 0
goldframe:SetScript("OnUpdate", function(self, e)
   elapsed = elapsed + e
   if elapsed >= 1 then
       goldRefresh()
       elapsed = 0
   end
end)

goldframe:SetScript("OnEvent", function()
       goldFS:SetTextColor(1, 1, 1);
       goldRefresh()
end)

function goldRefresh()
	local gold = GetMoney()
	goldFS:SetText(GetCoinTextureString(gold, 10))
end



--Bags Remaining
local Bagframe = CreateFrame("Frame", nil, statframe)
Bagframe:SetFrameStrata("BACKGROUND")
Bagframe:SetWidth(100)
Bagframe:SetHeight(26)
Bagframe:SetPoint("LEFT", statframe, "LEFT", 0, 0)
Bagframe:Show()

Bagframe:RegisterEvent("ZONE_CHANGED")
Bagframe:RegisterEvent("ZONE_CHANGED_INDOORS")
Bagframe:RegisterEvent("ZONE_CHANGED_NEW_AREA")

local BagframeFS = Bagframe:CreateFontString("FontString","OVERLAY","GameTooltipText")
local BagFS = Bagframe:CreateFontString("FontString","OVERLAY","GameTooltipText")

BagFS:SetPoint("BOTTOMLEFT",Bagframe,"BOTTOMLEFT",0,0)

local elapsed = 0
Bagframe:SetScript("OnUpdate", function(self, e)
   elapsed = elapsed + e
   if elapsed >= 1 then
       BagRefresh()
       elapsed = 0
   end
end)

Bagframe:SetScript("OnEvent", function()
       BagFS:SetTextColor(1, 1, 1);
       BagRefresh()
end)

function BagRefresh()
	local bagRem, bagTtl = 0, 0
		for i = 0, NUM_BAG_SLOTS do
			bagRem, bagTtl = bagRem + GetContainerNumFreeSlots(i), bagTtl + GetContainerNumSlots(i)
		end

	BagFS:SetFormattedText("B: %.0f", bagRem)
end



--Addon Memory
local show_mem = true
local addonframe = CreateFrame("Frame", nil, statframe)
addonframe:SetFrameStrata("BACKGROUND")
addonframe:SetWidth(100)
addonframe:SetHeight(26)
addonframe:SetPoint("BOTTOMRIGHT", statframe, "BOTTOMRIGHT", 0, 0)
addonframe:Show()

addonframe:RegisterEvent("ZONE_CHANGED")
addonframe:RegisterEvent("ZONE_CHANGED_INDOORS")
addonframe:RegisterEvent("ZONE_CHANGED_NEW_AREA")

local addonframeFS = addonframe:CreateFontString("FontString","OVERLAY","GameTooltipText")
local addonFS = addonframe:CreateFontString("FontString","OVERLAY","GameTooltipText")

addonFS:SetPoint("BOTTOMRIGHT",addonframe,"BOTTOMRIGHT",0,0)

local elapsed = 0
addonframe:SetScript("OnUpdate", function(self, e)
   elapsed = elapsed + e
   if elapsed >= 1 then
       addonRefresh()
       elapsed = 0
   end
end)

addonframe:SetScript("OnEvent", function()
       addonFS:SetTextColor(1, 1, 1);
       addonRefresh()
end)

function addonRefresh()
	if show_mem == true then
		local memory = 0
		UpdateAddOnMemoryUsage()
		for i = 1, GetNumAddOns() do
			if IsAddOnLoaded(i) then
				memory = memory + GetAddOnMemoryUsage(i)
			end
		end			
		mem = "|c00ffffff"..format("%.2f", memory / 1024).."|r MB"
	else
		mem = ""
	end
	addonFS:SetText(mem)
end



--Durability
local duraframe = CreateFrame("Frame", nil, statframe)
duraframe:SetFrameStrata("BACKGROUND")
duraframe:SetWidth(100)
duraframe:SetHeight(26)
duraframe:SetPoint("TOPLEFT", statframe, "TOPLEFT", 0, 0)
duraframe:Show()

duraframe:RegisterEvent("ZONE_CHANGED")
duraframe:RegisterEvent("ZONE_CHANGED_INDOORS")
duraframe:RegisterEvent("ZONE_CHANGED_NEW_AREA")

local duraframeFS = duraframe:CreateFontString("FontString","OVERLAY","GameTooltipText")
local duraFS = duraframe:CreateFontString("FontString","OVERLAY","GameTooltipText")

duraFS:SetPoint("BOTTOMLEFT",duraframe,"BOTTOMLEFT",0,0)

local elapsed = 0
duraframe:SetScript("OnUpdate", function(self, e)
   elapsed = elapsed + e
   if elapsed >= 1 then
       duraRefresh()
       elapsed = 0
   end
end)

duraframe:SetScript("OnEvent", function()
       duraFS:SetTextColor(1, 1, 1);
       duraRefresh()
end)

function duraRefresh()
	local durFull = true
		for slot, slotName in gmatch("1HEAD3SHOULDER5CHEST6WAIST7LEGS8FEET9WRIST10HANDS16MAINHAND17SECONDARYHAND18RANGED","(%d+)([^%d]+)") do
			local durCur, durMax = GetInventoryItemDurability(slot)
	local slotName = _G[slotName.."SLOT"]
			if ( durCur ~= durMax ) then
				duraFS:SetFormattedText("D: %.0f%%", durCur*(100/durMax))
			if ( durFull ) then 
			durFull = false 
			end
			end
			end
			
			if ( durFull ) then
			duraFS:SetText("D: 100%")
			end
	end